﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Infragistics.Win;
using Infragistics.Documents.Excel;
using System.Diagnostics;

namespace WinGridExportValueListImage
{
    public partial class Form1 : Form
    {
        List<Image> imageList = new List<Image>();
        ValueList retList1 = new ValueList();
        ValueList retList = new ValueList();
        public Form1()
        {
            InitializeComponent();
            LoadImages();
            
            DataTable table = new DataTable();
            table.Columns.Add("Object", typeof(string));
            table.Columns.Add("ImageList", typeof(Image));
            ValueListData(ref retList);
            ValueListData1(ref retList1);
            retList.SelectedIndex = 0;
            table.Rows.Add(retList.ValueListItems[0].DataValue, null);
            ultraGrid1.DataSource = table;
            
            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

            e.Layout.Bands[0].Columns["Object"].ValueList = retList;
            e.Layout.Bands[0].Columns["Object"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            retList.DisplayStyle = ValueListDisplayStyle.DisplayTextAndPicture;
            e.Layout.Bands[0].Columns["ImageList"].ValueList = retList1;
            retList1.DisplayStyle = ValueListDisplayStyle.Picture;
            
            e.Layout.Bands[0].Columns["Object"].CellAppearance.TextHAlign = HAlign.Right;
        }

        private void LoadImages()
        {
            DirectoryInfo dir = new DirectoryInfo("..\\..\\Images");
            foreach (FileInfo fi in dir.GetFiles())
            {
                if (fi.Extension == ".jpg")
                {
                    Image img = Image.FromFile(fi.FullName);
                    img.Tag = fi.Name;
                    imageList.Add(img);
                }
            }
        }

        private void ValueListData(ref ValueList retList)
        {
            retList = new ValueList();

            for (int i = 0; i < 10; i++)
            {
                ValueListItem item = new ValueListItem(imageList[i % imageList.Count].Tag.ToString(), imageList[i % imageList.Count].Tag.ToString());
                item.Appearance.Image = imageList[i % imageList.Count];
                
                retList.ValueListItems.Add(item);
            }
            

        }

        private void ValueListData1(ref ValueList retList)
        {
            retList = new ValueList();

            for (int i = 0; i < 10; i++)
            {
                ValueListItem item = new ValueListItem(imageList[i % imageList.Count], imageList[i % imageList.Count].Tag.ToString());
                item.Appearance.Image = imageList[i % imageList.Count];
                retList.ValueListItems.Add(item);
            }


        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraGridExcelExporter1.Export(ultraGrid1, "test.xlsx");
            Process.Start("test.xlsx");
        }

        private void ultraGridExcelExporter1_CellExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportingEventArgs e)
        {
            if (e.GridColumn.ValueList != null)
            { 
                Worksheet sheet = e.CurrentWorksheet;
                WorksheetCell cell = sheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex];
                cell.CellFormat.Alignment = HorizontalCellAlignment.Right;
                int width = 20;
                int height = sheet.Rows[e.CurrentRowIndex].Height != -1 ? sheet.Rows[e.CurrentRowIndex].Height : sheet.DefaultRowHeight;
                Image img;
                if (e.GridColumn.Key == "ImageList")
                {
                    img = e.GridRow.Cells[e.GridColumn.Key].Value as Image;
                    width = sheet.Columns[e.CurrentColumnIndex].Width != -1 ? sheet.Columns[e.CurrentColumnIndex].Width : sheet.DefaultColumnWidth;
                }
                else
                {
                    ValueListItem Retval = null;
                    foreach (ValueListItem val in retList.ValueListItems)
                    {
                        if (val.DisplayText.Equals(e.GridRow.Cells[e.GridColumn.Key].Text))
                            Retval = val;
                    }
                    img = Retval.Appearance.Image as Image;
                }

                if (img == null)
                    return;
                WorksheetImage shape = new WorksheetImage(img);
                
                shape.TopLeftCornerCell = cell;
                shape.TopLeftCornerPosition = new PointF(2, 2);
                shape.BottomRightCornerCell = cell;
                shape.BottomRightCornerPosition = new PointF(width, height);
                sheet.Shapes.Add(shape);
               
            }
        }
        
    }
}
